###################################################
### chunk number 1: 
###################################################
 options(continue="  ")
 options(width=65)


###################################################
### chunk number 2: 
###################################################
library("dse1")


###################################################
### chunk number 3: 
###################################################
data(eg1.DSE.data, package="dse1")  
data(egJofF.1dec93.data, package="dse1")  


###################################################
### chunk number 4: 
###################################################
fileName <- system.file("otherdata", "eg1.dat", package="dse1")
eg1.DSE.data <- t(matrix(scan(fileName),5, 364))[, 2:5]


###################################################
### chunk number 5: 
###################################################
eg1.DSE.data <- TSdata(input= eg1.DSE.data[,1,drop = F],
                      output= eg1.DSE.data[, 2:4, drop = F])


###################################################
### chunk number 6: 
###################################################
eg1.DSE.data <-tframed(eg1.DSE.data, 
          list(start=c(1961,3), frequency=12)) 


###################################################
### chunk number 7: 
###################################################
seriesNamesInput(eg1.DSE.data) <- "R90"
seriesNamesOutput(eg1.DSE.data) <- c("M1","GDPl2", "CPI") 


###################################################
### chunk number 8: 
###################################################
model1 <- estVARXls(eg1.DSE.data)
model2 <- estSSMittnik(eg1.DSE.data, n=4) 
# or model2 <- estSSMittnik(eg1.DSE.data) prompts for state dimension


###################################################
### chunk number 9: 
###################################################
summary(model1)
summary(model2)
model1
model2
stability(model1)
stability(model2)
informationTests(model1, model2)


###################################################
### chunk number 10: 
###################################################
tfplot(model1)
# plot(model1) this does not always work 
tfplot(model2)
tfplot(eg1.DSE.data)
checkResiduals(model1)
checkResiduals(model2) 


###################################################
### chunk number 11: 
###################################################
tfplot(model1)


###################################################
### chunk number 12: 
###################################################
AR <- array(c(1, .5, .3, 0, .2, .1, 0, .2, .05, 1, .5, .3), c(3,2,2)) 
MA <- array(c(1, .2, 0, .1, 0, 0, 1, .3), c(2,2,2)) 
arma <- ARMA(A=AR, B=MA, C=NULL) 
rm(AR, MA) # these can be removed from the environment as 
           #they are no longer needed 
arma 
stability(arma) 
data.arma.sim <- simulate(arma) 
arma <- l(arma, data.arma.sim) 
summary(arma) 
tfplot(data.arma.sim) 
tfplot(arma) 


###################################################
### chunk number 13: 
###################################################
f <- array(c(.5, .3, .2, .4), c(2,2)) # beware: do not use capital
                                      # F=FALSE as a variable name
h <- array(c(1, 0, 0, 1), c(2,2))
k <- array(c(.5, .3, .2, .4), c(2,2))
ss <- SS(F=f, H=h, K=k) # F is a function argument not a variable name
print(ss)
stability(ss)
data.ss.sim <- simulate(ss)
ss <- l(ss, data.ss.sim)
summary(ss)
tfplot(ss) 


###################################################
### chunk number 14: 
###################################################
ss.from.arma <- l(toSS(arma), data.arma.sim)
arma.from.ss <- l(toARMA(ss), data.ss.sim)
summary(ss.from.arma)
summary(arma)
summary(arma.from.ss)
summary(ss)
stability(arma)
stability(ss.from.arma) 


###################################################
### chunk number 15: 
###################################################
tfplot(state(ss))


###################################################
### chunk number 16: 
###################################################
ssc <- toSSChol(ss) 

ssc <- smoother(ssc)


###################################################
### chunk number 17: 
###################################################
tfplot(state(ssc, filter=TRUE))

tfplot(state(ssc, smoother=TRUE))


###################################################
### chunk number 18: 
###################################################
tfplot(state(ssc, smoother=TRUE), state(ssc, filter=TRUE))


###################################################
### chunk number 19: 
###################################################
model.eg1.ls <- estVARXls(trimNA(eg1.DSE.data)) 


###################################################
### chunk number 20: 
###################################################
subsample.data <- tfwindow(eg1.DSE.data, start=c(1972,1), 
   end=c(1992,12), warn=FALSE) 


###################################################
### chunk number 21: 
###################################################
summary(model.eg1.ls)
print(model.eg1.ls)
tfplot(model.eg1.ls)
checkResiduals(model.eg1.ls) 


###################################################
### chunk number 22: 
###################################################
model.eg1.ar <- estVARXar(trimNA(eg1.DSE.data))
model.eg1.ss <- estSSfromVARX(trimNA(eg1.DSE.data))
model.eg1.bft <- bft(trimNA(eg1.DSE.data))
model.eg1.mle <- estMaxLik(estVARXls(trimNA(eg1.DSE.data), max.lag=1)) # see note below 


###################################################
### chunk number 23: 
###################################################
tfplot(model.eg1.ls, model.eg1.ar)
tfplot(model.eg1.ls, model.eg1.ar, start=c(1990,1))


###################################################
### chunk number 24: 
###################################################
eg4.DSE.data<- egJofF.1dec93.data
outputData(eg4.DSE.data) <- outputData(eg4.DSE.data, series=c(1,2,6,7)) 


###################################################
### chunk number 25: 
###################################################
model.eg4.bb <- estBlackBox(trimNA(eg4.DSE.data), max.lag=3) 


###################################################
### chunk number 26: 
###################################################
informationTests(model.eg1.ar, model.eg1.ss) 


